/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

/**
 * @author Simon Gander
 */

public class Signalhalt extends SpurElement {
	public Signalhalt () {
		
	}
	
	public void initRoute (Signal s, SpurElement l, SpurElement r, boolean lr) {
		super.initRoute (l, r, 0);
		sig = s;
		vlnr = lr;
	}

	@Override
	public int signalDistanz(boolean richtung, int pos) {
		if (richtung == vlnr) return 0;
		if (richtung) {
			if (rechts == null) return 0;
			return laenge + rechts.signalDistanz (true, 0);
		} else {
			if (links == null) return 0;
			return pos + links.signalDistanz (false, links.laenge);
		}
	}
	
	boolean vlnr;
	Signal sig;
}
