/*
 * (c) 2005 by Simon Gander <simongander@gmx.ch>
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

package guettingen;

public class Weiche extends Gleis {
	public Weiche (int nr) {
		nummer = nr;
	}
	
	public final void initRoute (Lampe gl, SpurElement s, SpurElement p, SpurElement m, boolean spitz_links, int l) {
		spitz = s;
		plus = p;
		minus = m;
		laenge = l;
		sl = spitz_links;
		if (sl) {
			rechts = plus;
			links = spitz;
		} else {
			rechts = spitz;
			links = plus;
		}
		
		glampe = gl;
	}
	
	// Vom Hebel gesteuert
	public void stellen (boolean pos) {
		position = pos;
		if (pos) {
			if (sl) rechts = minus;
			else links = minus;
		} else {
			if (sl) rechts = plus;
			else links = plus;
		}
	}
	
	int nummer;
	boolean position;
	boolean sl;
	
	SpurElement spitz, plus, minus;
}
